//+------------------------------------------------------------------+
//|                                    MADAFOREX Trend Indicator.mq4 |
//|                                                     by MadaForex |
//+------------------------------------------------------------------+
#property copyright "MADAFOREX"
#property link      "MadaForex.tk"

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 CLR_NONE
#property indicator_color2 CLR_NONE
#property indicator_color3 Lime
#property indicator_color4 Red
#property indicator_width1 0
#property indicator_width2 0

//
//
//
//
//

extern string    MADAFOREX = "www.madaforex.tk";

extern string    MovingAverage_setup = ".: MOVING AVERAGES :.";
extern int       Fast_MA             = 5;
extern int       Slow_MA             = 12;
extern string    ex                  = "0=SMA,1=EMA,2=SSMA,3=LWMA";
extern int       mamode              = 1;
extern string    NOTE_MA_a           = "0=Close,1=Open,2=High,3=Low";
extern string    NOTE_MA_b           = "4=Median,5=Typical,6=Weighted";
extern int       maprice             = 0;

extern string    RSI_setup           = ".: RSI :. (Relative Strenght Index) ";
extern int       RSIPeriod           = 21;
extern int       RSILevelUp          = 50;
extern int       RSILevelDown        = 50;
extern string    NOTE_RSI_a          = "0=Close,1=Open,2=High,3=Low";
extern string    NOTE_RSI_b          = "4=Median,5=Typical,6=Weighted";
extern int       RSIprice            = 6;

extern string    Arrow_setup         = ".: ARROW :. ";
extern int       Arrow_Size          = 2;
extern int       ArrowUP_Symbol      = 233;
extern int       ArrowDN_Symbol      = 234;
extern double    Arrow_Shift         = 0.0;

extern string    Alert_setup         = ".: ALERT :. ";
extern bool      Alerts              = True;
extern bool 	  Email	             = false;
extern string	  MailSubject         = "MADAFOREX X-trem V1 Alert";

double           ExtMapBuffer1[];
double           ExtMapBuffer2[];
double           ExtMapBuffer3[];
double           ExtMapBuffer4[];
double           trend[];
datetime         lastAlert;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int init()
{
   IndicatorBuffers(5);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexBuffer(2,ExtMapBuffer3); SetIndexStyle(2,DRAW_ARROW,0,Arrow_Size); SetIndexArrow(2,ArrowUP_Symbol);
   SetIndexBuffer(3,ExtMapBuffer4); SetIndexStyle(3,DRAW_ARROW,0,Arrow_Size); SetIndexArrow(3,ArrowDN_Symbol);
   SetIndexBuffer(4,trend);
   lastAlert=Time[0];
   return(0);
}
int deinit() { return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+


int start()
{
   int counted_bars=IndicatorCounted();
   int limit;
   
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit=MathMin(Bars-counted_bars,Bars-1);
  
   for(int i=limit; i>=0; i--)
   {
      ExtMapBuffer1[i] = iMA(NULL,0,Fast_MA,0,mamode,maprice,i);
      ExtMapBuffer2[i] = iMA(NULL,0,Slow_MA,0,mamode,maprice,i);
      ExtMapBuffer3[i] = EMPTY_VALUE;
      ExtMapBuffer4[i] = EMPTY_VALUE;
      trend[i]         = trend[i+1];

      //
      //
      
      double dist = iATR(NULL,0,20,i);
      double rsi  = iRSI(NULL, 0, RSIPeriod, RSIprice, i);
      double ac1  = iAC(NULL,0,i);
      double ac2  = iAC(NULL,0,i+1);
      double diff = (ExtMapBuffer1[i]-ExtMapBuffer2[i]);

         if (/**/ac1>ac2 && diff>=0  && rsi>=RSILevelUp ) trend[i] =  1;
         if (/**/ac1<ac2 && diff<=0  && rsi<=RSILevelDown ) trend[i] = -1;
         if (trend[i]!=trend[i+1])
            if (trend[i]==1)
                  ExtMapBuffer3[i] = Low[i]-((Arrow_Shift)*dist);
            else  ExtMapBuffer4[i] = High[i]+((Arrow_Shift)*dist);  
   }

   //
   //

   if (trend[1]!=trend[2])
   {
   	     if(Time[0]>lastAlert) {
   	           lastAlert=Time[0];
   	           string alert;
               if (trend[1] > 0) alert = Symbol()+", MADAFOREX X-trem V1 Buy Entry at "+DoubleToStr(Ask,Digits)+"!!";
               else  alert = Symbol()+", MADAFOREX X-trem V1 Sell Entry point at "+DoubleToStr(Bid,Digits)+"!!";
               
               if(Alerts) Alert(alert);
               if(Email) SendMail(MailSubject,alert);
         }
   }              
   return(0);
}


